<?php
class ControllerExtensionModuleRouteeCustomers extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/routee/customers');

		$this->document->setTitle($this->language->get('heading_title'));
		
		// Send Data to Routee
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/routee/customers', 'user_token=' . $this->session->data['user_token'], true)
		);

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}
		
		if (isset($this->session->data['error_warning'])) {
			$data['error_warning'] = $this->session->data['error_warning'];

			unset($this->session->data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}
		
		$this->load->model('customer/customer');
		$sort = 'name';
		$order = 'ASC';
		$module_routee_customer_limit = $this->config->get('module_routee_customer_limit');
		if($module_routee_customer_limit <= 0)
		{
			$this->load->model('setting/setting');
			$this->model_setting_setting->editSettingValue('module_routee', 'module_routee_customer_limit', 1);
		}
		
		$filter_data = array(
			'filter_name'              => '',
			'filter_email'             => '',
			'filter_customer_group_id' => '',
			'filter_status'            => '',
			'filter_date_added'        => '',
			'filter_ip'                => '',
			'sort'                     => $sort,
			'order'                    => $order,
			'start'           		   => ($module_routee_customer_limit - 1) * $this->config->get('config_limit_admin'),
			'limit'           		   => $this->config->get('config_limit_admin')
		);
		
		$customerData = $this->model_customer_customer->getCustomers($filter_data);
		$customer_count = count($customerData);
		if(($customer_count == 0) && ($customer_count < $this->config->get('config_limit_admin')))
		{
			$data['customer_exists'] = 0;
		}
		else
		{
			$data['customer_exists'] = 1;
		}
		//echo $customer_count; print_r($customerData); exit;
		
		
		$data['user_token'] = $this->session->data['user_token'];
		
		$data['insert'] = $this->url->link('extension/module/routee/customers/insert', 'user_token=' . $this->session->data['user_token'], true);
		
		$data['insert_mass'] = $this->url->link('extension/module/routee/customers/insert_mass', 'user_token=' . $this->session->data['user_token'], true);
		
		$data['insert_mass_import'] = str_replace('&amp;', '&', $this->url->link('extension/module/routee/customers/insert_mass', 'user_token=' . $this->session->data['user_token'], true));
		
		$module_routee_customer_limit = $this->config->get('module_routee_customer_limit');
		$data['module_routee_customer_limit'] = $module_routee_customer_limit;
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/routee/customers', $data));
		
		//$resultCustomer = $this->insertCustomerData();
		//print_r($resultCustomer); exit;
	}
	
	public function insert() {
		$this->load->language('extension/module/routee/customers');
		
		$this->load->model('customer/customer');
		$sort = 'name';
		$order = 'ASC';
		$page = '1';
		
		$filter_data = array(
			'filter_name'              => '',
			'filter_email'             => '',
			'filter_customer_group_id' => '',
			'filter_status'            => '',
			'filter_date_added'        => '',
			'filter_ip'                => '',
			'sort'                     => $sort,
			'order'                    => $order,
			'start'                    => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit'                    => $this->config->get('config_limit_admin')
		);
		
		$customer_total = $this->model_customer_customer->getTotalCustomers($filter_data);
		$customerData = $this->model_customer_customer->getCustomers($filter_data);
		
		$success = $failed = $not_exist = 0;
		
		if($this->config->get('module_routee_uuid') != "")
		{
			if($customerData)
			{
				$resultJson = array();
				foreach($customerData as $k => $customerRow)
				{
					$customerCartValue = array();
							
					$customerCartValue['data'] = $customerRow;
					$customerCartValue["uuid"] = $this->config->get('module_routee_uuid');
					$customerCartValue["event"] = 'Customers';
					
					$postData = json_encode($customerCartValue);
		
					$ch = curl_init('https://idata.routee.net/api/event');                                                                      
					curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
					curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);                                                                  
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					$result = curl_exec($ch);
					
					$this->load->library('routee');
					$this->routee->write("Event Customers: ".json_encode($customerCartValue)." Result: ".$result);
					
					$resultJson[$k] = json_decode($result, 1);
				}
				
				//echo '<pre>'; print_r($resultJson); exit;
				
				if(isset($resultJson))
				{
					foreach($resultJson as $k => $message)
					{
						if($message['message'] == "Valid Data")
						{
							$this->session->data['success'] = $this->language->get('text_success');
							$success++;
						}
						else
						{
							$this->session->data['error_warning'] = $this->language->get('text_error');
							$failed++;
						}
					}
				}
				else
				{
					$this->session->data['error_warning'] = $this->language->get('text_not_imported');
					$failed++;
				}
			}
			else
			{
				$this->session->data['success'] = $this->language->get('text_all_imported');
				$this->session->data['customers_not_exists'] = 1;
				$not_exist++;
			}
		}
		
		$counterArr = array('success' => $success, 'error' => $failed, 'not_exist' => $not_exist);
		
		if($failed > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_error');
		}
		else if($not_exist > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_not_exists');
		}
		else
		{
			$this->session->data['success'] = $this->language->get('text_success');
		}
		
		$this->response->redirect($this->url->link('extension/module/routee/customers', 'user_token=' . $this->session->data['user_token'], true));
	}
	
	public function insert_mass() {
		$this->load->language('extension/module/routee/customers');
		
		$this->load->model('customer/customer');
		$this->load->model('extension/module/customer_cart');
		
		$sort = 'name';
		$order = 'ASC';
		$module_routee_customer_limit = $this->config->get('module_routee_customer_limit');
		
		$filter_data_total = array(
			'filter_name'              => '',
			'filter_email'             => '',
			'filter_customer_group_id' => '',
			'filter_status'            => '',
			'filter_date_added'        => '',
			'filter_ip'                => '',
			'sort'                     => $sort,
			'order'                    => $order,
			'start'                    => ($module_routee_customer_limit - 1) * $this->config->get('config_limit_admin'),
			'limit'                    => $this->config->get('config_limit_admin')
		);
		
		$customer_total = $this->model_customer_customer->getTotalCustomers($filter_data_total);
		
		$filter_data = array(
			'filter_name'              => '',
			'filter_email'             => '',
			'filter_customer_group_id' => '',
			'filter_status'            => '',
			'filter_date_added'        => '',
			'filter_ip'                => '',
			'sort'                     => $sort,
			'order'                    => $order,
			'start'           		   => ($module_routee_customer_limit - 1) * $this->config->get('config_limit_admin'),
			'limit'           		   => $this->config->get('config_limit_admin')
		);
		
		$customerData = $this->model_customer_customer->getCustomers($filter_data);
		
		$success = $failed = $not_exist = 0;
		
		if($this->config->get('module_routee_uuid') != "")
		{
			$resultJson = array();
			$customerCartValue = $customerInfo = array();
			
			if($customerData)
			{
				unset($this->session->data['customers_not_exists']);
				
				$count = 0;
				foreach($customerData as $k => $customerRow)
				{
					$customerRow['id'] = $customerRow['customer_id'];
					$customerRow['phone'] = $customerRow['telephone'];
					
					unset($customerRow['cart']);
					$customerCartData = $this->model_extension_module_customer_cart->getCart($customerRow['customer_id']);
					
					$customerCart = array();
					if($customerCartData)
					{
						foreach($customerCartData as $k => $cartData)
						{
							$customerCart['cart_products'][] = array('product_id' => $cartData['product_id'], 'option' => $cartData['option'], 'quantity' => $cartData['quantity']);
						}
					}
					//$customerRow['cart'] = $customerCart;
					
					// Address Data
					$customerAddressData = $this->model_customer_customer->getAddresses($customerRow['customer_id']);
					
					$customerAddress = array();
					if($customerAddressData)
					{
						foreach($customerAddressData as $k => $cartAddressRow)
						{
							$cartAddressRow['address1'] = $cartAddressRow['address_1'];
							$cartAddressRow['address2'] = $cartAddressRow['address_2'];
							
							unset($cartAddressRow['address_1']);
							unset($cartAddressRow['address_2']);
							
							$customerAddress[] = $cartAddressRow;
						}
					}
					//$customerRow['addresses'] = $customerAddress;
					
					unset($customerRow['customer_id']);
					unset($customerRow['telephone']);
					$customerInfo[] = array('customer' => $customerRow, 'cart' => $customerCart, 'addresses' => $customerAddress);
				}
				
				$customerCartValue["uuid"] = $this->config->get('module_routee_uuid');
				
				
				$customerCartValue['data'][0]["name"] = 'Customers';
				$customerCartValue['data'][0]["description"] = 'Shop Customers';
				$customerCartValue['data'][0]['object'] = $customerInfo;
				
				//echo '<pre>'; print_r($customerCartValue); exit;
				
				$postData = json_encode($customerCartValue);
				
				//echo '<pre>'; print_r($postData); exit;
		
				$ch = curl_init('https://idata.routee.net/api/data');							  
				curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
				curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);                                                                  
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				$result = curl_exec($ch);
				
				$this->load->library('routee');
				$this->routee->write("Mass Customers: ".json_encode($customerCartValue)." Result: ".$result);
				
				$resultJson = json_decode($result, 1);
				
				//echo '<pre>'; print_r($resultJson); exit;
				
				if(isset($resultJson))
				{
					if(!empty($resultJson['message']))
					{
						$module_routee_customer_limit1 = $module_routee_customer_limit + 1;
						
						$this->load->model('setting/setting');
						
						$this->model_setting_setting->editSettingValue('module_routee', 'module_routee_customer_limit', $module_routee_customer_limit1);
						
						$resultOutput = sprintf($this->language->get('text_success'), ($customer_total) ? (($module_routee_customer_limit - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($module_routee_customer_limit - 1) * $this->config->get('config_limit_admin')) > ($customer_total - $this->config->get('config_limit_admin'))) ? $customer_total : ((($module_routee_customer_limit - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $customer_total, ceil($customer_total / $this->config->get('config_limit_admin')));
						
						$this->session->data['success'] = $resultOutput;
					}
					else
					{
						$this->session->data['error_warning'] = $this->language->get('text_error');
					}
				}
				else
				{
					$this->session->data['error_warning'] = $this->language->get('text_not_imported');
				}
			}
			else
			{
				//$this->session->data['success'] = $this->language->get('text_all_imported');
				$this->session->data['customers_not_exists'] = 1;
				$not_exist++;
			}
		}
		
		$counterArr = array('success' => $success, 'error' => $failed, 'not_exist' => $not_exist);
		
		if($failed > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_error');
		}
		else if($not_exist > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_not_exists');
		}
		else
		{
			$this->session->data['success'] = sprintf($this->language->get('text_success'), ($customer_total) ? (($module_routee_customer_limit - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($module_routee_customer_limit - 1) * $this->config->get('config_limit_admin')) > ($customer_total - $this->config->get('config_limit_admin'))) ? $customer_total : ((($module_routee_customer_limit - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $customer_total, ceil($customer_total / $this->config->get('config_limit_admin')));
		}
		
		$this->response->redirect($this->url->link('extension/module/routee/customers', 'user_token=' . $this->session->data['user_token'].'&module_routee_customer_limit='.$module_routee_customer_limit, true));
	}
}