<?php
class ControllerExtensionModuleRouteeOrders extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/routee/orders');

		$this->document->setTitle($this->language->get('heading_title'));
		
		// Send Data to Routee
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/routee/orders', 'user_token=' . $this->session->data['user_token'], true)
		);

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}
		
		if (isset($this->session->data['error_warning'])) {
			$data['error_warning'] = $this->session->data['error_warning'];

			unset($this->session->data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}
		
		$this->load->model('sale/order');
		$sort = 'o.order_id';
		$order = 'DESC';
		$module_routee_order_limit = $this->config->get('module_routee_order_limit');
		if($module_routee_order_limit <= 0)
		{
			$this->load->model('setting/setting');
			$this->model_setting_setting->editSettingValue('module_routee', 'module_routee_order_limit', 1);
		}
		
		$filter_data = array(
			'filter_order_id'        => '',
			'filter_customer'	     => '',
			'filter_order_status'    => '',
			'filter_order_status_id' => '',
			'filter_total'           => '',
			'filter_date_added'      => '',
			'filter_date_modified'   => '',
			'sort'           		 => $sort,
			'order'          		 => $order,
			'start'           => ($module_routee_order_limit - 1) * $this->config->get('config_limit_admin'),
			'limit'           => $this->config->get('config_limit_admin')
		);
		

		$orderData = $this->model_sale_order->getOrders($filter_data);
		$order_count = count($orderData);
		if(($order_count == 0) && ($order_count < $this->config->get('config_limit_admin')))
		{
			$data['order_exists'] = 0;
		}
		else
		{
			$data['order_exists'] = 1;
		}
		
		
		$data['user_token'] = $this->session->data['user_token'];
		
		$data['insert'] = $this->url->link('extension/module/routee/orders/insert', 'user_token=' . $this->session->data['user_token'], true);
		
		$data['insert_mass'] = $this->url->link('extension/module/routee/orders/insert_mass', 'user_token=' . $this->session->data['user_token'], true);
		
		$data['insert_mass_import'] = str_replace('&amp;', '&', $this->url->link('extension/module/routee/orders/insert_mass', 'user_token=' . $this->session->data['user_token'], true));
		
		$module_routee_order_limit = $this->config->get('module_routee_order_limit');
		$data['module_routee_order_limit'] = $module_routee_order_limit;
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/routee/orders', $data));
		
		//$resultOrder = $this->insertOrderData();
		//print_r($resultOrder); exit;
	}
	
	public function insert() {
		$this->load->language('extension/module/routee/orders');
		
		$this->load->model('sale/order');
		$sort = 'o.order_id';
		$order = 'DESC';
		$page = '1';
		
		$filter_data = array(
			'filter_order_id'        => '',
			'filter_customer'	     => '',
			'filter_order_status'    => '',
			'filter_order_status_id' => '',
			'filter_total'           => '',
			'filter_date_added'      => '',
			'filter_date_modified'   => '',
			'sort'            => $sort,
			'order'           => $order,
			'start'           => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit'           => $this->config->get('config_limit_admin')
		);
		
		$order_total = $this->model_sale_order->getTotalOrders($filter_data);

		$orderData = $this->model_sale_order->getOrders($filter_data);
		
		$success = $failed = $not_exist = 0;
		
		if($this->config->get('module_routee_uuid') != "")
		{
			if($orderData)
			{
				$resultJson = array();
				foreach($orderData as $k => $orderRow)
				{
					$customerCartValue = array();
							
					$customerCartValue['data'] = $orderRow;
					$customerCartValue["uuid"] = $this->config->get('module_routee_uuid');
					$customerCartValue["event"] = 'Orders';
					
					$postData = json_encode($customerCartValue);
		
					$ch = curl_init('https://idata.routee.net/api/event');                                                                      
					curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
					curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);                                                                  
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					$result = curl_exec($ch);
					
					$this->load->library('routee');
					$this->routee->write("Event Orders: ".json_encode($customerCartValue)." Result: ".$result);
					
					$resultJson[$k] = json_decode($result, 1);
				}
				
				//echo '<pre>'; print_r($resultJson); exit;
				
				if(isset($resultJson))
				{
					foreach($resultJson as $k => $message)
					{
						if($message['message'] == "Valid Data")
						{
							$this->session->data['success'] = $this->language->get('text_success');
							$success++;
						}
						else
						{
							$this->session->data['error_warning'] = $this->language->get('text_error');
							$failed++;
						}
					}
				}
				else
				{
					$this->session->data['error_warning'] = $this->language->get('text_not_imported');
					$failed++;
				}
			}
			else
			{
				$this->session->data['success'] = $this->language->get('text_all_imported');
				$this->session->data['orders_not_exists'] = 1;
				$not_exist++;
			}
		}
		
		$counterArr = array('success' => $success, 'error' => $failed, 'not_exist' => $not_exist);
		
		if($failed > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_error');
		}
		else if($not_exist > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_not_exists');
		}
		else
		{
			$this->session->data['success'] = $this->language->get('text_success');
		}
		
		$this->response->redirect($this->url->link('extension/module/routee/orders', 'user_token=' . $this->session->data['user_token'], true));
	}
	
	public function insert_mass() {
		$this->load->language('extension/module/routee/orders');
		
		$this->load->model('sale/order');
		$sort = 'o.order_id';
		$order = 'DESC';
		$module_routee_order_limit = $this->config->get('module_routee_order_limit');
		
		$filter_data_total = array();
		$order_total = $this->model_sale_order->getTotalOrders($filter_data_total);
		
		$filter_data = array(
			'filter_order_id'        => '',
			'filter_customer'	     => '',
			'filter_order_status'    => '',
			'filter_order_status_id' => '',
			'filter_total'           => '',
			'filter_date_added'      => '',
			'filter_date_modified'   => '',
			'sort'           		 => $sort,
			'order'          		 => $order,
			'start'           => ($module_routee_order_limit - 1) * $this->config->get('config_limit_admin'),
			'limit'           => $this->config->get('config_limit_admin')
		);
		

		$orderData = $this->model_sale_order->getOrders($filter_data);
		
		$success = $failed = $not_exist = 0;
		
		if($this->config->get('module_routee_uuid') != "")
		{
			$resultJson = array();
			$customerCartValue = $orderInfo = array();
			
			if($orderData)
			{
				unset($this->session->data['orders_not_exists']);
				$resultJson = array();
				foreach($orderData as $k => $orderRow)
				{
					$order = array();
					
					$order_info = $this->model_sale_order->getOrder($orderRow['order_id']);
					if($order_info)
					{
						$order['order_details'] = array('customer_id' => $order_info['customer_id'], 'order_id' => $order_info['order_id'], 'order_status' => $order_info['order_status'], 'shipping_method' => $order_info['shipping_method'], 'payment_method' => $order_info['payment_method'], 'total_price' => $order_info['total']);
					}
					
					$order_products = array();
					$products = $this->model_sale_order->getOrderProducts($orderRow['order_id']);

					foreach ($products as $product) {
						$order_products[] = array(
							'product_id' => $product['product_id'],
							'quantity'   => $product['quantity'],
						);
					}
					
					$order['order_products'] = $order_products;
					
					/*$order['order_vouchers'] = $this->model_sale_order->getOrderVouchers($orderRow['order_id']);
					
					$order_totals = $this->model_sale_order->getOrderTotals($orderRow['order_id']);
	
					$orderTotal = array();
					foreach ($order_totals as $order_total) {
						// If coupon, voucher or reward points
						$start = strpos($order_total['title'], '(') + 1;
						$end = strrpos($order_total['title'], ')');
		
						if ($start && $end) {
							$orderTotal[$order_total['code']] = substr($order_total['title'], $start, $end - $start);
						}
					}
					
					$order['order_total'] = $orderTotal;*/
					
					$orderInfo[] = $order;
				}
				
				$customerCartValue["uuid"] = $this->config->get('module_routee_uuid');
				
				
				$customerCartValue['data'][0]["name"] = 'Orders';
				$customerCartValue['data'][0]["description"] = 'Shop Orders';
				$customerCartValue['data'][0]['object'] = $orderInfo;
				
				//echo '<pre>'; print_r($customerCartValue); exit;
				
				$postData = json_encode($customerCartValue);
				
				//echo '<pre>'; print_r($postData); exit;
			
				$ch = curl_init('https://idata.routee.net/api/data');
				curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
				curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);                                                                  
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				$result = curl_exec($ch);
				
				$this->load->library('routee');
				$this->routee->write("Mass Orders: ".json_encode($customerCartValue)." Result: ".$result);
				
				$resultJson = json_decode($result, 1);
				
				//echo '<pre>'; print_r($resultJson); exit;
				
				if(isset($resultJson))
				{
					if(!empty($resultJson['message']))
					{
						$module_routee_order_limit1 = $module_routee_order_limit + 1;
						
						$this->load->model('setting/setting');
						
						$this->model_setting_setting->editSettingValue('module_routee', 'module_routee_order_limit', $module_routee_order_limit1);
						
						$resultOutput = sprintf($this->language->get('text_success'), ($order_total) ? (($module_routee_order_limit - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($module_routee_order_limit - 1) * $this->config->get('config_limit_admin')) > ($order_total - $this->config->get('config_limit_admin'))) ? $order_total : ((($module_routee_order_limit - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $order_total, ceil($order_total / $this->config->get('config_limit_admin')));
						$this->session->data['success'] = $resultOutput;
					}
					else
					{
						$this->session->data['error_warning'] = $this->language->get('text_error');
					}
				}
				else
				{
					$this->session->data['error_warning'] = $this->language->get('text_not_imported');
					$failed++;
				}
			}
			else
			{
				//$this->session->data['success'] = $this->language->get('text_all_imported');
				$this->session->data['orders_not_exists'] = 1;
				$not_exist++;
			}
		}
		
		$counterArr = array('success' => $success, 'error' => $failed, 'not_exist' => $not_exist);
		
		if($failed > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_error');
		}
		else if($not_exist > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_not_exists');
		}
		else
		{
			$this->session->data['success'] = sprintf($this->language->get('text_success'), ($order_total) ? (($module_routee_order_limit - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($module_routee_order_limit - 1) * $this->config->get('config_limit_admin')) > ($order_total - $this->config->get('config_limit_admin'))) ? $order_total : ((($module_routee_order_limit - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $order_total, ceil($order_total / $this->config->get('config_limit_admin')));
		}
		
		$this->response->redirect($this->url->link('extension/module/routee/orders', 'user_token=' . $this->session->data['user_token'], true));
	}
}