<?php
class ControllerExtensionModuleRouteeProducts extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/routee/products');

		$this->document->setTitle($this->language->get('heading_title'));
		
		// Send Data to Routee
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/routee/products', 'user_token=' . $this->session->data['user_token'], true)
		);

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}
		
		if (isset($this->session->data['error_warning'])) {
			$data['error_warning'] = $this->session->data['error_warning'];

			unset($this->session->data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}
		
		$this->load->model('catalog/product');
		$this->load->model('catalog/category');
		$sort = 'pd.name';
		$order = 'ASC';
		$module_routee_product_limit = $this->config->get('module_routee_product_limit');
		if($module_routee_product_limit <= 0)
		{
			$this->load->model('setting/setting');
			$this->model_setting_setting->editSettingValue('module_routee', 'module_routee_product_limit', 1);
		}
		
		$filter_data = array(
			'filter_name'	  => '',
			'filter_model'	  => '',
			'filter_price'	  => '',
			'filter_quantity' => '',
			'filter_status'   => '',
			'sort'            => $sort,
			'order'           => $order,
			'start'           => ($module_routee_product_limit - 1) * $this->config->get('config_limit_admin'),
			'limit'           => $this->config->get('config_limit_admin')
		);
		

		$productData = $this->model_catalog_product->getProducts($filter_data);
		$product_count = count($productData);
		if(($product_count == 0) && ($product_count < $this->config->get('config_limit_admin')))
		{
			$data['product_exists'] = 0;
		}
		else
		{
			$data['product_exists'] = 1;
		}
		
		$data['user_token'] = $this->session->data['user_token'];
		
		$data['insert'] = $this->url->link('extension/module/routee/products/insert', 'user_token=' . $this->session->data['user_token'], true);
		
		$data['insert_mass'] = $this->url->link('extension/module/routee/products/insert_mass', 'user_token=' . $this->session->data['user_token'], true);
		
		$data['insert_mass_import'] = str_replace('&amp;', '&', $this->url->link('extension/module/routee/products/insert_mass', 'user_token=' . $this->session->data['user_token'], true));
		
		$module_routee_product_limit = $this->config->get('module_routee_product_limit');
		$data['module_routee_product_limit'] = $module_routee_product_limit;
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/routee/products', $data));
		
		//$resultProduct = $this->insertProductData();
		//print_r($resultProduct); exit;
	}
	
	public function insert() {
		$this->load->language('extension/module/routee/products');
		
		$this->load->model('catalog/product');
		$sort = 'pd.name';
		$order = 'ASC';
		$page = '1';
		
		$filter_data = array(
			'filter_name'	  => '',
			'filter_model'	  => '',
			'filter_price'	  => '',
			'filter_quantity' => '',
			'filter_status'   => '',
			'sort'            => $sort,
			'order'           => $order,
			'start'           => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit'           => $this->config->get('config_limit_admin')
		);
		
		$product_total = $this->model_catalog_product->getTotalProducts($filter_data);

		$productData = $this->model_catalog_product->getProducts($filter_data);
		
		$success = $failed = $not_exist = 0;
		
		if($this->config->get('module_routee_uuid') != "")
		{
			if($productData)
			{
				$resultJson = array();
				foreach($productData as $k => $productRow)
				{
					$customerCartValue = array();
							
					$customerCartValue['data'] = $productRow;
					$customerCartValue["uuid"] = $this->config->get('module_routee_uuid');
					$customerCartValue["event"] = 'Products';
					
					$postData = json_encode($customerCartValue);
		
					$ch = curl_init('https://idata.routee.net/api/event');                                                                      
					curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
					curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);                                                                  
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					$result = curl_exec($ch);
					
					$this->load->library('routee');
					$this->routee->write("Event Products: ".json_encode($customerCartValue)." Result: ".$result);
					
					$resultJson[$k] = json_decode($result, 1);
				}
				
				//echo '<pre>'; print_r($resultJson); exit;
				
				if(isset($resultJson))
				{
					foreach($resultJson as $k => $message)
					{
						if($message['message'] == "Valid Data")
						{
							$this->session->data['success'] = $this->language->get('text_success');
							$success++;
						}
						else
						{
							$this->session->data['error_warning'] = $this->language->get('text_error');
							$failed++;
						}
					}
				}
				else
				{
					$this->session->data['error_warning'] = $this->language->get('text_not_imported');
					$failed++;
				}
			}
			else
			{
				$this->session->data['success'] = $this->language->get('text_all_imported');
				$this->session->data['products_not_exists'] = 1;
				$not_exist++;
			}
		}
		
		$counterArr = array('success' => $success, 'error' => $failed, 'not_exist' => $not_exist);
		
		if($failed > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_error');
		}
		else if($not_exist > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_not_exists');
		}
		else
		{
			$this->session->data['success'] = $this->language->get('text_success');
		}
		
		$this->response->redirect($this->url->link('extension/module/routee/products', 'user_token=' . $this->session->data['user_token'], true));
	}
	
	public function insert_mass() {
		$this->load->language('extension/module/routee/products');
		
		$this->load->model('catalog/product');
		$this->load->model('catalog/category');
		$sort = 'pd.name';
		$order = 'ASC';
		$module_routee_product_limit = $this->config->get('module_routee_product_limit');
		
		$filter_data_total = array();
		$product_total = $this->model_catalog_product->getTotalProducts($filter_data_total);
		
		$filter_data = array(
			'filter_name'	  => '',
			'filter_model'	  => '',
			'filter_price'	  => '',
			'filter_quantity' => '',
			'filter_status'   => '',
			'sort'            => $sort,
			'order'           => $order,
			'start'           => ($module_routee_product_limit - 1) * $this->config->get('config_limit_admin'),
			'limit'           => $this->config->get('config_limit_admin')
		);
		

		$productData = $this->model_catalog_product->getProducts($filter_data);
		
		$success = $failed = $not_exist = 0;
		
		if($this->config->get('module_routee_uuid') != "")
		{
			$resultJson = array();
			$customerCartValue = $productInfo = array();
			
			if($productData)
			{
				unset($this->session->data['products_not_exists']);
				$count = 0;
				foreach($productData as $k => $productRow)
				{
					$searchProduct = array();
				
					$special = false;

					$product_specials = $this->model_catalog_product->getProductSpecials($productRow['product_id']);
		
					foreach ($product_specials  as $product_special) {
						if (($product_special['date_start'] == '0000-00-00' || strtotime($product_special['date_start']) < time()) && ($product_special['date_end'] == '0000-00-00' || strtotime($product_special['date_end']) > time())) {
							$special = $product_special['price'];
		
							break;
						}
					}
			
					//$product_info = $this->model_catalog_product->getProduct($productRow['product_id']);
					
					//echo '<pre>';  print_r($product_info);
					
					$category = array();
					
					$categories = $this->model_catalog_product->getProductCategories($productRow['product_id']);
					
					foreach ($categories as $category_id) {
						$category_info = $this->model_catalog_category->getCategory($category_id);
			
						if ($category_info) {
							$category[] = $category_info['name'];
						}
					}
					
					$image_link = $product_link = "";
					
					if (isset($productRow['image'])) {
						$image_link = HTTP_CATALOG.$productRow['image'];
					}
					
					$product_link = HTTP_CATALOG.'index.php?route=product/product&product_id='.$productRow['product_id'];
					
					$discount = array();
					
					$product_discounts = $this->model_catalog_product->getProductDiscounts($productRow['product_id']);
					
					foreach ($product_discounts as $product_discount) {
						$discount[] = array(
							'price'             => $this->tax->calculate($product_discount['price'], $productRow['tax_class_id'], $this->config->get('config_tax')),		
							'quantity'          => $product_discount['quantity'],
							'date_start'        => ($product_discount['date_start'] != '0000-00-00') ? $product_discount['date_start'] : '',
							'date_end'          => ($product_discount['date_end'] != '0000-00-00') ? $product_discount['date_end'] : ''
						);
					}
					
					$product_description = $this->model_catalog_product->getProductDescriptions($productRow['product_id']);
					
					if($special)
					{
						$price = $special;
					}
					else
					{
						$price = $productRow['price'];
					}
					
					foreach ($product_description as $language_id => $value) {
						$searchProduct = array('product_id' => $productRow['product_id'], 'name' => $value['name'], 'description' => html_entity_decode($value['description'], ENT_QUOTES, 'UTF-8'), 'categories' => $category, 'stock_quantity' => $productRow['quantity'], 'price' => $this->tax->calculate($price, $productRow['tax_class_id'], $this->config->get('config_tax')), 'discount' => $discount, 'image_link' => $image_link, 'product_link' => $product_link);
					}
					
					//$productInfo[$k][$k] = $productRow;
					$productInfo[] = $searchProduct;
				}
				
				$customerCartValue["uuid"] = $this->config->get('module_routee_uuid');
				
				
				$customerCartValue['data'][0]["name"] = 'Products';
				$customerCartValue['data'][0]["description"] = 'Shop Products';
				$customerCartValue['data'][0]['object'] = $productInfo;
				
				//echo '<pre>';  print_r($customerCartValue); exit;
				
				$postData = json_encode($customerCartValue);
				
				//echo $postData; exit;
			
				$ch = curl_init('https://idata.routee.net/api/data');
				curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
				curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);                                                                  
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				$result = curl_exec($ch);
				
				$this->load->library('routee');
				$this->routee->write("Mass Products: ".json_encode($customerCartValue)." Result: ".$result);
				
				$resultJson = json_decode($result, 1);
				
				//echo '<pre>'; print_r($resultJson); exit;
				
				if(isset($resultJson))
				{
					if(!empty($resultJson['message']))
					{
						$module_routee_product_limit1 = $module_routee_product_limit + 1;
						
						$this->load->model('setting/setting');
						
						$this->model_setting_setting->editSettingValue('module_routee', 'module_routee_product_limit', $module_routee_product_limit1);
						
						$resultOutput = sprintf($this->language->get('text_success'), ($product_total) ? (($module_routee_product_limit - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($module_routee_product_limit - 1) * $this->config->get('config_limit_admin')) > ($product_total - $this->config->get('config_limit_admin'))) ? $product_total : ((($module_routee_product_limit - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $product_total, ceil($product_total / $this->config->get('config_limit_admin')));
						$this->session->data['success'] = $resultOutput;
					}
					else
					{
						$this->session->data['error_warning'] = $this->language->get('text_error');
					}
				}
				else
				{
					$this->session->data['error_warning'] = $this->language->get('text_not_imported');
				}
			}
			else
			{
				//$this->session->data['success'] = $this->language->get('text_all_imported');
				$this->session->data['products_not_exists'] = 1;
				$not_exist++;
			}
		}
		
		$counterArr = array('success' => $success, 'error' => $failed, 'not_exist' => $not_exist);
		
		if($failed > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_error');
		}
		else if($not_exist > 0)
		{
			$this->session->data['error_warning'] = $this->language->get('text_not_exists');
		}
		else
		{
			$this->session->data['success'] = sprintf($this->language->get('text_success'), ($product_total) ? (($module_routee_product_limit - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($module_routee_product_limit - 1) * $this->config->get('config_limit_admin')) > ($product_total - $this->config->get('config_limit_admin'))) ? $product_total : ((($module_routee_product_limit - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $product_total, ceil($product_total / $this->config->get('config_limit_admin')));
		}
		
		$this->response->redirect($this->url->link('extension/module/routee/products', 'user_token=' . $this->session->data['user_token'], true));
	}
}